Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/GPCrossoverBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/GPCrossoverBase.cs	(revision 3218)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/GPCrossoverBase.cs	(revision 3219)
@@ -23,8 +23,6 @@
 using HeuristicLab.Core;
 using System.Diagnostics;
-using HeuristicLab.Evolutionary;
-using HeuristicLab.GP.Interfaces;
 
-namespace HeuristicLab.GP.Operators {
+namespace HeuristicLab.Encodings.SymbolicExpressionTree {
   public abstract class GPCrossoverBase : CrossoverBase {
     public GPCrossoverBase()
Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/LangdonHomologousCrossOver.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/LangdonHomologousCrossOver.cs	(revision 3218)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/LangdonHomologousCrossOver.cs	(revision 3219)
@@ -25,5 +25,5 @@
 using HeuristicLab.GP.Interfaces;
 
-namespace HeuristicLab.GP.Operators {
+namespace HeuristicLab.Encodings.SymbolicExpressionTree {
   /// <summary>
   /// Implementation of a homologous crossover operator as described in: 
Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/OnePointCrossOver.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/OnePointCrossOver.cs	(revision 3218)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/OnePointCrossOver.cs	(revision 3219)
@@ -24,5 +24,5 @@
 using HeuristicLab.GP.Interfaces;
 
-namespace HeuristicLab.GP.Operators {
+namespace HeuristicLab.Encodings.SymbolicExpressionTree {
   /// <summary>
   /// Implementation of a homologous one point crossover operator as described in: 
Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/SizeConstrictedGPCrossoverBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/SizeConstrictedGPCrossoverBase.cs	(revision 3218)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/SizeConstrictedGPCrossoverBase.cs	(revision 3219)
@@ -24,5 +24,5 @@
 using HeuristicLab.GP.Interfaces;
 
-namespace HeuristicLab.GP.Operators {
+namespace HeuristicLab.Encodings.SymbolicExpressionTree {
   public abstract class SizeConstrictedGPCrossoverBase : GPCrossoverBase {
 
Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/SizeFairCrossOver.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/SizeFairCrossOver.cs	(revision 3218)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/SizeFairCrossOver.cs	(revision 3219)
@@ -26,5 +26,5 @@
 using HeuristicLab.Random;
 
-namespace HeuristicLab.GP.Operators {
+namespace HeuristicLab.Encodings.SymbolicExpressionTree {
   /// <summary>
   /// Implementation of a size fair crossover operator as described in: 
Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/StandardCrossOver.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/StandardCrossOver.cs	(revision 3218)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/StandardCrossOver.cs	(revision 3219)
@@ -24,5 +24,5 @@
 using HeuristicLab.GP.Interfaces;
 
-namespace HeuristicLab.GP.Operators {
+namespace HeuristicLab.Encodings.SymbolicExpressionTree {
   public class StandardCrossOver : SizeConstrictedGPCrossoverBase {
     private int MaxRecombinationTries { get { return 20; } }
Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/UniformCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/UniformCrossover.cs	(revision 3218)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTree/3.3/Crossovers/UniformCrossover.cs	(revision 3219)
@@ -22,7 +22,6 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
-using HeuristicLab.GP.Interfaces;
 
-namespace HeuristicLab.GP.Operators {
+namespace HeuristicLab.Encodings.SymbolicExpressionTree {
   /// <summary>
   /// Implementation of a homologous uniform crossover operator as described in: 