Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs	(revision 3245)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs	(revision 3246)
@@ -62,5 +62,5 @@
       this.repetitionsLabel = new System.Windows.Forms.Label();
       this.repetitionsNumericUpDown = new System.Windows.Forms.NumericUpDown();
-      this.resultsView = new HeuristicLab.Optimization.Views.ResultCollectionListView();
+      this.resultsView = new HeuristicLab.Optimization.Views.ResultCollectionView();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl.SuspendLayout();
@@ -273,5 +273,5 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.resultsView.Caption = "ResultCollectionList";
+      this.resultsView.Caption = "ResultCollection";
       this.resultsView.Content = null;
       this.resultsView.Location = new System.Drawing.Point(6, 6);
@@ -334,5 +334,5 @@
     private System.Windows.Forms.Label repetitionsLabel;
     private System.Windows.Forms.NumericUpDown repetitionsNumericUpDown;
-    private ResultCollectionListView resultsView;
+    private ResultCollectionView resultsView;
 
   }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 3245)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 3246)
@@ -98,10 +98,4 @@
       <DependentUpon>BatchRunView.cs</DependentUpon>
     </Compile>
-    <Compile Include="ResultCollectionListView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ResultCollectionListView.Designer.cs">
-      <DependentUpon>ResultCollectionListView.cs</DependentUpon>
-    </Compile>
     <Compile Include="UserDefinedAlgorithmView.cs">
       <SubType>UserControl</SubType>
Index: unk/sources/HeuristicLab.Optimization.Views/3.3/ResultCollectionListView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultCollectionListView.Designer.cs	(revision 3245)
+++ 	(revision )
@@ -1,53 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Optimization.Views {
-  partial class ResultCollectionListView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing) {
-        if (components != null) components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      components = new System.ComponentModel.Container();
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-    }
-
-    #endregion
-  }
-}
Index: unk/sources/HeuristicLab.Optimization.Views/3.3/ResultCollectionListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultCollectionListView.cs	(revision 3245)
+++ 	(revision )
@@ -1,53 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Collections;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Optimization.Views {
-  [View("ResultCollectionList View")]
-  [Content(typeof(ResultCollectionList), true)]
-  public partial class ResultCollectionListView : ItemListView<ResultCollection> {
-    /// <summary>
-    /// Initializes a new instance of <see cref="VariablesScopeView"/> with caption "Variables Scope View".
-    /// </summary>
-    public ResultCollectionListView() {
-      InitializeComponent();
-      Caption = "ResultCollectionList";
-      itemsGroupBox.Text = "Results";
-    }
-    /// <summary>
-    /// Initializes a new instance of <see cref="VariablesScopeView"/> with 
-    /// the given <paramref name="scope"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="VariablesScopeView()"/>.</remarks>
-    /// <param name="scope">The scope whose variables should be represented visually.</param>
-    public ResultCollectionListView(ResultCollectionList content)
-      : this() {
-      Content = content;
-    }
-
-    protected override ResultCollection CreateItem() {
-      return null;
-    }
-  }
-}
Index: /trunk/sources/HeuristicLab.Optimization/3.3/BatchRun.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/BatchRun.cs	(revision 3245)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/BatchRun.cs	(revision 3246)
@@ -74,6 +74,6 @@
 
     [Storable]
-    private ResultCollectionList results;
-    public ResultCollectionList Results {
+    private ResultCollection results;
+    public ResultCollection Results {
       get { return results; }
     }
@@ -111,15 +111,15 @@
       : base() {
       repetitions = 10;
-      results = new ResultCollectionList();
+      results = new ResultCollection();
       executionTime = TimeSpan.Zero;
     }
     public BatchRun(string name) : base(name) {
       repetitions = 10;
-      results = new ResultCollectionList();
+      results = new ResultCollection();
       executionTime = TimeSpan.Zero;
     }
     public BatchRun(string name, string description) : base(name, description) {
       repetitions = 10;
-      results = new ResultCollectionList();
+      results = new ResultCollection();
       executionTime = TimeSpan.Zero;
     }
@@ -129,5 +129,5 @@
       clone.Algorithm = (IAlgorithm)cloner.Clone(algorithm);
       clone.repetitions = repetitions;
-      clone.results = (ResultCollectionList)cloner.Clone(results);
+      clone.results = (ResultCollection)cloner.Clone(results);
       clone.executionTime = executionTime;
       clone.running = running;
@@ -208,5 +208,5 @@
 
     private void Algorithm_Prepared(object sender, EventArgs e) {
-      results.Add(Algorithm.Results);
+      results.Add(new Result("Run " + DateTime.Now.ToString(), Algorithm.Results));
     }
     private void Algorithm_RunningChanged(object sender, EventArgs e) {
Index: /trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 3245)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 3246)
@@ -87,5 +87,4 @@
     <Compile Include="Algorithm.cs" />
     <Compile Include="BatchRun.cs" />
-    <Compile Include="ResultCollectionList.cs" />
     <Compile Include="Interfaces\IMultiObjectiveSolutionsVisualizer.cs" />
     <Compile Include="Interfaces\IResult.cs" />
Index: unk/sources/HeuristicLab.Optimization/3.3/ResultCollectionList.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/ResultCollectionList.cs	(revision 3245)
+++ 	(revision )
@@ -1,35 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Optimization {
-  [StorableClass]
-  [Item("ResultCollectionList", "Represents list of result collections.")]
-  public sealed class ResultCollectionList : ItemList<ResultCollection> {
-    public ResultCollectionList() : base() { }
-    public ResultCollectionList(int capacity) : base(capacity) { }
-    public ResultCollectionList(IEnumerable<ResultCollection> collection) : base(collection) { }
-  }
-}